module Config where

import Prelude
import Data.Text (Text)
import GHC.Generics (Generic)
import Data.Aeson (FromJSON, ToJSON)

import Achille
import Achille.Task
import Achille.Path (Path)
import Achille.Pandoc (readPandocMetaWith, renderPandocWith)
import Text.Pandoc.Builder (Pandoc)

import Text.Pandoc.Options as Pandoc

ropts :: Pandoc.ReaderOptions
ropts = def { readerExtensions = pandocExtensions }

wopts :: Pandoc.WriterOptions
wopts = def { writerHTMLMathMethod = KaTeX "" }

readPandoc :: FromJSON a => Task IO Path -> Task IO (a, Pandoc)
readPandoc = readPandocMetaWith ropts

renderPandoc :: Task IO Pandoc -> Task IO Text
renderPandoc = renderPandocWith wopts

data PageInfo = PageInfo
    { title       :: Text
    , description :: Text
    } deriving (Generic, ToJSON)

info :: PageInfo
info = PageInfo
  { title       = "Lucas Escot"
  , description = "My professional page"
  }
